<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SyncExecutorConfigurer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.executors.sync</a> &gt; <span class="el_source">SyncExecutorConfigurer.java</span></div><h1>SyncExecutorConfigurer.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.executors.sync;

import io.gitlab.littlesaints.protean.Graph;
import io.gitlab.littlesaints.protean.Node;
import io.gitlab.littlesaints.protean.Processor;
import io.gitlab.littlesaints.protean.analytics.StatsListener;
import io.gitlab.littlesaints.protean.event.EventAccessor;
import io.gitlab.littlesaints.protean.event.State;
import lombok.extern.log4j.Log4j2;

import java.util.*;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Stream;

import static io.gitlab.littlesaints.protean.EventExecutor.*;

/**
 * The class builds a {@link Stream} to continually process the incoming events.
 * It's used by the {@link SyncExecutor} to prepare the processing workflow / pipeline as per the {@link Graph} configuration.
 *
 * @author Varun Anand
 * @since 1.0
 */
<span class="fc" id="L45">@Log4j2</span>
class SyncExecutorConfigurer&lt;E&gt; {

    private final String contextName;

    private final Graph&lt;E&gt; graph;

    private final Set&lt;String&gt; configuredStages;

    private final Map&lt;String, Node&lt;E&gt;&gt; nodes;

    private final Map&lt;String, Collection&lt;String&gt;&gt; dependencies;

    private final Map&lt;String, Collection&lt;String&gt;&gt; hierarchy;

    private final Queue&lt;String&gt; queue;

    private final StatsListener&lt;E&gt; statsListener;

    private final EventAccessor&lt;E, ?&gt; eventAccessor;

<span class="fc" id="L66">    SyncExecutorConfigurer(String contextName, Graph&lt;E&gt; graph, StatsListener&lt;E&gt; statsListener, EventAccessor&lt;E, ?&gt; eventAccessor) {</span>
<span class="fc" id="L67">        this.contextName = contextName;</span>
<span class="fc" id="L68">        this.graph = graph;</span>
<span class="fc" id="L69">        nodes = graph.getNodesMap();</span>
<span class="fc" id="L70">        dependencies = graph.getDependencies();</span>
<span class="fc" id="L71">        hierarchy = graph.getHierarchy();</span>
<span class="fc" id="L72">        queue = new ArrayDeque&lt;&gt;(dependencies.size());</span>
<span class="fc" id="L73">        configuredStages = new HashSet&lt;&gt;();</span>
<span class="fc" id="L74">        this.statsListener = statsListener;</span>
<span class="fc" id="L75">        this.eventAccessor = eventAccessor;</span>
<span class="fc" id="L76">    }</span>

    Function&lt;E, E&gt; configure(Collection&lt;Runnable&gt; closeActions) {
<span class="fc" id="L79">        configuredStages.clear();</span>
<span class="fc" id="L80">        queue.clear();</span>
<span class="fc" id="L81">        queue.addAll(graph.getRoots());</span>

        String stageName;
<span class="fc" id="L84">        Function&lt;E, E&gt; function = e -&gt; e;</span>
<span class="fc bfc" id="L85" title="All 2 branches covered.">        while (!queue.isEmpty()) {</span>
<span class="fc" id="L86">            stageName = queue.remove();</span>
<span class="fc bfc" id="L87" title="All 2 branches covered.">            if (!configuredStages.contains(stageName)) {</span>
<span class="fc bfc" id="L88" title="All 4 branches covered.">                if (!dependencies.containsKey(stageName) || configuredStages.containsAll(dependencies.get(stageName))) {</span>
<span class="fc" id="L89">                    final Node&lt;E&gt; node = nodes.get(stageName);</span>
<span class="fc bfc" id="L90" title="All 2 branches covered.">                    if (node.getConcurrency() &gt; 1) {</span>
<span class="fc" id="L91">                        log.warn(&quot;Executor &quot; + contextName + &quot; :: the configured executor doesn't support parallelism and this configuration will be ignored. &quot; +</span>
                                &quot;It's a synchronous executor, where the publisher thread executes the workflow serially. &quot;);
                    }
<span class="fc" id="L94">                    function = function.andThen(configureSerialStageProcessing(node, closeActions));</span>
<span class="fc" id="L95">                    configuredStages.add(stageName);</span>
<span class="fc bfc" id="L96" title="All 2 branches covered.">                    if (hierarchy.containsKey(stageName)) {</span>
<span class="fc" id="L97">                        queue.addAll(hierarchy.get(stageName));</span>
                    }
<span class="fc" id="L99">                } else {</span>
<span class="fc" id="L100">                    queue.add(stageName);</span>
                }
            }
        }

<span class="fc" id="L105">        return function;</span>
    }

    private Function&lt;E, E&gt; configureSerialStageProcessing(Node&lt;E&gt; node, Collection&lt;Runnable&gt; closeActions) {
<span class="fc" id="L109">        final boolean skippable = node.isSkippable();</span>
        //TODO: can we do better than thread local ?
<span class="fc" id="L111">        final ThreadLocal&lt;Function&lt;E, State&gt;&gt; processorRef = ThreadLocal.withInitial(() -&gt; {</span>
<span class="fc" id="L112">            Processor&lt;E&gt; p = node.getProcessorSupplier().get();</span>
<span class="fc" id="L113">            closeActions.add(p::close);</span>
<span class="fc" id="L114">            return newExecutionOp(p.getFunction(), node.getExceptionHandler(), node.getRetryStrategy());</span>
        });

        final Function&lt;E, E&gt; function;
<span class="pc bpc" id="L118" title="1 of 2 branches missed.">        if (node.getFilter() == null) {</span>
<span class="fc" id="L119">            function = e -&gt; {</span>
<span class="fc bfc" id="L120" title="All 2 branches covered.">                if (filter(e, skippable, null, eventAccessor::getState)) {</span>
<span class="fc" id="L121">                    process(processorRef.get(), e, eventAccessor::getState, eventAccessor::setState);</span>
                }
<span class="fc" id="L123">                return e;</span>
            };
        } else {
<span class="nc" id="L126">            final ThreadLocal&lt;Predicate&lt;E&gt;&gt; filterRef = ThreadLocal.withInitial(() -&gt; node.getFilter().get());</span>
<span class="nc" id="L127">            function = e -&gt; {</span>
<span class="nc bnc" id="L128" title="All 2 branches missed.">                if (filter(e, skippable, filterRef.get(), eventAccessor::getState)) {</span>
<span class="nc" id="L129">                    process(processorRef.get(), e, eventAccessor::getState, eventAccessor::setState);</span>
                }
<span class="nc" id="L131">                return e;</span>
            };
        }

<span class="fc bfc" id="L135" title="All 2 branches covered.">        if (statsListener == null) {</span>
<span class="fc" id="L136">            return function;</span>
        } else {
<span class="fc" id="L138">            return e -&gt; {</span>
<span class="fc" id="L139">                long startMillis = System.currentTimeMillis();</span>
<span class="fc" id="L140">                return function.andThen(ev -&gt; {</span>
<span class="fc" id="L141">                    statsListener.eventProcessed(contextName, e, node.getName(), startMillis, System.currentTimeMillis());</span>
<span class="fc" id="L142">                    return ev;</span>
<span class="fc" id="L143">                }).apply(e);</span>
            };
        }
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>